apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ bbbcsp_name }}
  name: {{ bbbcsp_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ bbbcsp_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ bbbcsp_name }}
  strategy:
    type: RollingUpdate
{% else %}
    name: {{ bbbcsp_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Rolling
{% endif %}
  template:
    metadata:
      labels:
        name: {{ bbbcsp_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ bbbcsp_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ bbbcsp_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      containers:
      - env:
{% if (airbrake_id | default(False)) and (airbrake_key | default(False)) %}
        - name: AIRBRAKE_ID
          valueFrom:
            secretKeyRef:
              key: airbrake-id
              name: {{ bbbcsp_name }}-airbrake
        - name: AIRBRAKE_KEY
          valueFrom:
            secretKeyRef:
              key: airbrake-key
              name: {{ bbbcsp_name }}-airbrake
{% if airbrake_host | default(False) %}
        - name: AIRBRAKE_HOST
          valueFrom:
            secretKeyRef:
              key: airbrake-host
              name: {{ bbbcsp_name }}-airbrake
{% endif %}
{% else %}
        - name: AIRBRAKE_ID
          value: ""
        - name: AIRBRAKE_KEY
          value: ""
{% endif %}
        - name: BBBLIVESTREAM_IMAGE
          value: "{{ (opsimages | json_query("[?name=='bbblivestream'].image"))[0] }}"
        - name: BIGBLUEBUTTON_API_URL
          value: "{{ bigbluebutton_endpoint }}"
        - name: BIGBLUEBUTTON_API_SECRET
{% if scalelite_api_public | default(False) and ((scalelite_namespace | default(False)) == namespace) %}
          valueFrom:
            secretKeyRef:
              key: loadbalancer-key
              name: {{ scalelite_api_secret }}
{% else %}
          valueFrom:
            secretKeyRef:
              key: loadbalancer-key
              name: {{ bbbcsp_name }}-bigbluebutton
{% endif %}
        - name: CONTAINERS_DRIVER
          value: kubernetes
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: KUBERNETES_LABEL_NAME
          value: managedby
        - name: KUBERNETES_LABEL_VALUE
          value: {{ bbbcsp_name }}
        - name: KUBERNETES_NAMESPACE
          valueFrom:
            fieldRef:
              fieldPath: metadata.namespace
        - name: KUBERNETES_STREAM_CPU_LIMIT
          value: "{{ bbblivestream_cpu_limit }}"
        - name: KUBERNETES_STREAM_CPU_REQUEST
          value: "{{ bbblivestream_cpu_request }}"
        - name: KUBERNETES_STREAM_MEMORY_LIMIT
          value: "{{ bbblivestream_memory_limit }}"
        - name: KUBERNETES_STREAM_MEMORY_REQUEST
          value: "{{ bbblivestream_memory_request }}"
        - name: NODE_TLS_REJECT_UNAUTHORIZED
          value: "0"
        - name: PEERTUBE_API_URL
          value: "{{ peertube_endpoint }}"
        - name: PEERTUBE_PASSWORD
{% if peertube_api_public | default(False) and ((peertube_namespace | default(False)) == namespace) %}
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ peertube_name }}
        - name: PEERTUBE_USERNAME
          valueFrom:
            secretKeyRef:
              key: admin-user
              name: {{ peertube_name }}
{% else %}
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ bbbcsp_name }}-peertube
        - name: PEERTUBE_USERNAME
          valueFrom:
            secretKeyRef:
              key: admin-user
              name: {{ bbbcsp_name }}-peertube
{% endif %}
{% if peertube_rtmp_address | default(False) %}
        - name: RTMP_PREFIX
          value: "{{ peertube_rtmp_address }}/live"
{% endif %}
        - name: SERVE_STATIC_ASSETS
          value: simpler-for-now
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='bbbcsp'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='bbbcsp'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 12
          httpGet:
            path: /index.html
            port: 8080
          initialDelaySeconds: 60
          periodSeconds: 30
          timeoutSeconds: 5
        name: bbbcsp
        ports:
        - containerPort: 8080
        readinessProbe:
          httpGet:
            path: /index.html
            port: 8080
          initialDelaySeconds: 20
          periodSeconds: 10
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ bbbcsp_cpu_limit }}"
            memory: "{{ bbbcsp_memory_limit }}"
          requests:
            cpu: "{{ bbbcsp_cpu_request }}"
            memory: "{{ bbbcsp_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /opt/app-root/src/static/js/backend.js
          name: config
          subPath: backend.js
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
      serviceAccountName: {{ bbbcsp_name }}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ bbbcsp_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - configMap:
          name: {{ bbbcsp_name }}
        name: config
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='bbbcsp'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - bbbcsp
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='bbbcsp'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
